#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define N 201
typedef struct {
	int x, y;
}POINT;
POINT points[N]; /* input coordinates */
POINT colors[N*N]; /* coordinates of points coresponding to colors */
int colorscount[N*N];
int grf[N][N*N]; /* vertex i is connected with vertex grf[i][j] by an edge of color j */
int n, total_colors;

/* create colored edges among points on input according to symmetry */
void create_graph(){
	int i,j,k,l,x,y;
	l = 0;
	for(i = 1; i <= n; i++){
		for(j = i; j <= n; j++){
			x = (points[i].x + points[j].x); /* /2 */
			y = (points[i].y + points[j].y); /* /2 */

			/* this can be optimalized... */
			for(k = 0; k < l; k++)
				if(colors[k].x == x && colors[k].y == y) {
					colorscount[k]+=(i==j)?1:2;
					break;
				}
			if(k==l){
				colors[l].x = x; colors[l].y = y;
				colorscount[l] = (i==j)?1:2;
				l++;
			}
			grf[i][k] = j;
			grf[j][k] = i;
		}
	}
	total_colors = l;
}

/* test if c1 and c2 can form perfect matching */
int is_pm(int c1, int c2){

	if (colorscount[c1] + colorscount[c2] < n)
		return 0;
	
	int i,j,c;
	static int matched[N];
	for(i = 1; i <= n; i++)
		matched[i] = 0;
	for(i = 1; i <= n; i++){
		if(!matched[i]){

			/* point may be the point of reflection itself */
			if(grf[i][c1] == i || grf[i][c2] == i){
				matched[i] = 1; 
				continue;
			}

			c = 0;
			j = i;
			/* check presence of odd cycle/path */
			do{
				matched[j] = 1; c++;
				if(grf[j][c1] != 0 && matched[grf[j][c1]] == 0)
					j = grf[j][c1];
				else if(grf[j][c2] != 0 && matched[grf[j][c2]] == 0)
					j = grf[j][c2];
				else break;
			}while(1);

			if(c > 2 && (grf[j][c1] == i || grf[j][c2] == i)){	/* cycle */
				if( c%2 ) {
					return 0;}
				continue;
			}
			
			j = i; c--; /* we would count i twice, thus c-- */
			do{
				matched[j] = 1; c++;
				if(grf[j][c1] != 0 && matched[grf[j][c1]] == 0)
					j = grf[j][c1];
				else if(grf[j][c2] != 0 && matched[grf[j][c2]] == 0)
					j = grf[j][c2];
				else break;
			}while(1);

			if(c%2){
				return 0;}
		}
	}
	return 1;
}

int read_input(){
	int i;
	scanf("%d",&n);
	for(i=1;i<=n;i++)
		scanf("%d %d",&points[i].x,&points[i].y);
}

int main(){
	int i,j;
	read_input();
	create_graph();
	/* fix vertex 1 in first set */	
	int found = 0;
	for(i=0; i < total_colors; i++){
//		if( grf[1][i] != 0 ){
			for(j=0; j < total_colors; j++){
				if(is_pm(i,j)){
					#define DEC(a) a/2,(a%2)?".5":""
					printf("%d%s %d%s %d%s %d%s\n",DEC(colors[i].x),DEC(colors[i].y),DEC(colors[j].x),DEC(colors[j].y));
found = 1;
#ifndef ALL
//return 0;
#endif
//					printf("%d\n", colorscount[i] + colorscount[j]);
				}
			}
//		}
	}
if (!found)
	printf("MATRIX PANIC\n");
	return 0;
}
